class Mailer private {
  def from(addr: String) = { println("from"); this }
  def to(addr: String) = { println("to"); this }
  def sub(line: String) = { println("sub"); this }
  def msg(body: String) = { println("msg"); this }
}

object Mailer {
  def send(block : Mailer => Unit) = {
    val mailer = new Mailer
    block(mailer)
    println("sending...")
  }
}

Mailer.send { mailer =>
  mailer.from("..")
        .to("...")
        .sub("...")
        .msg("...")  
}
